# Orchid Information Manager
# This shows AR Customer comments in the notes popup.
# Field 1 should be the Customer Number field.
# Create a category called 'FOLLOWUP' in I/M Options - Note Categories
from accpac import *
import eb
import datetime
import locale
import time

# init is called when the script is first loaded.
def init(arg):
	pass

def accpacDateToDate(d):
	if d == "0":
		return None
	return datetime.date(int(d[0:4]), int(d[4:6]), int(d[6:8]))

def plaintToRtf(plain):
	rtf = plain
	rtf = rtf.replace("\\", "\\\\")
	rtf = rtf.replace("{", "\\{")
	rtf = rtf.replace("}", "\\}")
	rtf = rtf.replace("\r\n", "\\par\r\n")
	return rtf

def onRefreshContent():
	locale.setlocale(locale.LC_ALL, "")
	now = time.strftime("%Y%m%d")
	eb.clearAll()
	vARCMM = openView("AR0021", 1)
	if vARCMM == None:
		return
	vARCMM.recordClear()
	vARCMM.browse("IDCUST=\"" + eb.value1 + "\" AND (DATEEXPR=0 OR DATEEXPR>" + sessionDate() + ")", True)
	n = 0
	while vARCMM.fetch() == 0:
		n = n + 1
		dtEntered = accpacDateToDate(vARCMM.get("DATEENTR"))
		dtExpired = accpacDateToDate(vARCMM.get("DATEEXPR"))
		dtFollow = accpacDateToDate(vARCMM.get("DATEFLUP"))
		t = "{\\rtf1\\ansi\\deff0{\\fonttbl{\\f0\\fnil\\fcharset0 MS Shell Dlg;}}\\viewkind4\\uc1\\pard\\lang1033\\f0\\fs16 "
		eol = "\\par\r\n"
		if dtEntered != None:
			t = t + "Entered: " + dtEntered.strftime("%x") + eol
		if dtExpired != None:
			t = t + "Expires: " + dtExpired.strftime("%x") + eol
		if dtFollow != None:
			if now > vARCMM.get("DATEFLUP"):
				t = t + "Follow-up: \\b " + dtFollow.strftime("%x") + "\\b0 " + eol
			else:
				t = t + "Follow-up: " + dtFollow.strftime("%x") + eol
		t = t + eol
		t = t + plaintToRtf(vARCMM.get("TEXTCMNT").strip()) + eol
		t = t + eol
		t = t + "Created by " + vARCMM.get("USERID").strip() + "}"

		note = eb.addNote(t)
		if dtFollow != None:
			if now > vARCMM.get("DATEFLUP"):
				note.category = "FOLLOWUP"
		if eb.rotoID != "AR1300":
			note.button1 = "Open"
		note.name = str(n)

# Button1 is the 'Open' button. It opens AR Customers.
def onAction_Button1(ctrlName):
	openUI("AR1300", "IDCUST=" + eb.value1, False)
